<template>
	<v-row justify="center">
		<v-card width="500">
			<v-form class="form">
				<v-text-field
					label="Username"
					v-model="form_username"
					prepend-icon="mdi-account"
					required
				></v-text-field>
				<v-text-field
					label="Password"
					prepend-icon="lock"
					:append-icon="show_password ? 'mdi-eye' : 'mdi-eye-off'"
					:type="show_password ? 'text' : 'password'"
					v-model="form_password"
					@click:append="show_password = !show_password"
					@keyup.enter="submit"
					required
				></v-text-field>
				<span class="error--text" v-if="!valid">Your login information is incorrect!</span>
				<span class="error--text" v-if="error">Something went wrong. Please try again later.</span>
				<v-btn
					class="submit"
					block
					color="success"
					@click="submit"
					v-bind:loading="loading"
					>Login</v-btn
				>
			</v-form>
		</v-card>
		<v-snackbar v-model="redirected" bottom right color="error">
			<template v-if="loggedIn">
        		You do not have sufficient permissions to access {{next_route}}!
			</template>
			<template v-else>
				You need to log in before accessing {{next_route}}!
			</template>
      	</v-snackbar>
	</v-row>
</template>

<script>
import { httpPost } from '@/utils/connection';
export default {
	name: "Login",
	data() {
		return {
			valid: true,
			error: false,
			show_password: false,
			redirected: false,
			next_route: "",
			loading: false,
			form_username: this.$store.state.username,
			form_password: ""
		};
	},
	computed: {
		loggedIn () {
			return this.$store.getters.loggedIn
		}
	},
	methods: {
		async submit() {
			this.loading = true;
			try {
				let response = await httpPost(process.env.VUE_APP_API_URL + "/login", {
					username: this.form_username,
					password: this.form_password
				})

				if (response) {
					this.valid = true;
					this.$store.dispatch("set_token", response.token);
					this.$store.commit("set_username", this.form_username);
					this.$router.push(this.next_route)
				} else {
					this.valid = false;
					this.form_password = "";
				}
				this.error = false;
			} catch (e) {
				console.log(e)
				this.error = true;
			} finally {
				this.loading = false;
			}
		}
	},
	beforeRouteEnter(to, from, next) {
		next(vm => {
			//go back to previous page after we're done logging in
			vm.next_route = from.fullPath 

			//it doesn't make sense to try and sign up after we have logged in, just redirect to home
			//also we're avoiding redundant navigation to login
			if(from.fullPath === "/register" || from.fullPath === "/login") vm.next_route = "/"

			//we tried to access a protected route without being logged in => redirect after we're done
			if(to.query.redirectFrom !== undefined){
				vm.next_route = to.query.redirectFrom;
				vm.redirected = true;
			}


		})

  }
};
</script>

<style scoped>
.submit {
	margin-top: 30px;
}
.form {
	padding: 30px;
}
</style>